﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

namespace PACNET
{
    /// <summary>microSD Management API</summary>
    public partial class Memory
    {
        //6.1. PAC_API bool pac_SDExists()
        /// <summary>
        /// This function is used to check that the Micro SD whether has been standby ready or not.
        /// </summary>
        /// <returns>Return true if success, otherwise false.</returns>    
        [DllImport("PACSDK.dll", EntryPoint = "pac_SDExists")]
        [return: MarshalAs(UnmanagedType.I1)]
        public static extern bool SDExists();

        //6.2. PAC_API bool pac_SDMount(LPTSTR szPartitionName)
        /// <summary>
        /// This function is used to mount Micro SD if the Micro SD has been inserting to the device
        /// without mounting.
        /// </summary>
        /// <param name="szPartitionName">[in] Name of the partition. Example Part00.</param>
        /// <returns>Return true if success, otherwise false.</returns>    
        [DllImport("PACSDK.dll", EntryPoint = "pac_SDMount")]
        [return: MarshalAs(UnmanagedType.I1)]
        public static extern bool SDMount(string szPartitionName);

        //6.3. PAC_API bool pac_SDOnside()
        /// <summary>
        /// This function is used to check the Micro SD whether on-side or not.
        /// </summary>
        /// <returns>Return true if success, otherwise false.</returns>    
        [DllImport("PACSDK.dll", EntryPoint = "pac_SDOnside")]
        [return: MarshalAs(UnmanagedType.I1)]
        public static extern bool SDOnside();

        //6.4. PAC_API bool pac_SDUnmount()
        /// <summary>
        /// This function is used to dismount Micro SD if the Micro SD has been mounted.
        /// </summary>
        /// <returns>Return true if success, otherwise false.</returns>    
        [DllImport("PACSDK.dll", EntryPoint = "pac_SDUnmount")]
        [return: MarshalAs(UnmanagedType.I1)]
        public static extern bool SDUnmount();
    }
}