﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

namespace PACNET
{
    /// <summary></summary>
    public partial class Sys
    {
        /// <summary>Watchdog API</summary>
        public class WDT
        {
            /// <summary>WDT_HW</summary>
            public const int PAC_WDT_HW = 0;

            /// <summary>WDT_OS</summary>
            public const int PAC_WDT_OS = 1;


            //5.1. PAC_API void pac_DisableWatchDog(int wdt)
            /// <summary>
            /// This function turns off the watchdog operation.
            /// </summary>
            /// <param name="wdt">[in] Specifies the Watchdog type:
            /// 0: pac_WDT_HW, 1: pac_WDT_OS</param>
            /// <returns>The return value specifies the memory size.</returns>    
            [DllImport("PACSDK.dll", EntryPoint = "pac_DisableWatchDog")]
            public static extern void DisableWatchDog(int wdt);

            //5.2. PAC_API bool pac_EnableWatchDog(int wdt, DWORD value)
            /// <summary>
            /// This function turns on the watchdog operation.
            /// </summary>
            /// <param name="wdt">[in] Specifies the Watchdog type:
            /// 0: pac_WDT_HW, 1: pac_WDT_OS</param>
            /// <param name="value">[in] Specifies the watchdog time.</param>
            /// <returns>Return true if success, otherwise false.</returns>    
            [DllImport("PACSDK.dll", EntryPoint = "pac_EnableWatchDog")]
            [return: MarshalAs(UnmanagedType.I1)]
            public static extern bool EnableWatchDog(int wdt, uint value);

            //5.3. PAC_API bool pac_GetWatchDogState(int wdt)
            /// <summary>
            /// This function retrieves the watchdog state.
            /// </summary>
            /// <param name="wdt">[in] Specifies the Watchdog type:
            /// 0: pac_WDT_HW, 1: pac_WDT_OS</param>
            /// <returns>The return value specifies the watchdog state.
            /// If turning on, return true, otherwise false.</returns>    
            [DllImport("PACSDK.dll", EntryPoint = "pac_GetWatchDogState")]
            [return: MarshalAs(UnmanagedType.I1)]
            public static extern bool GetWatchDogState(int wdt);

            //5.4. PAC_API DWORD pac_GetWatchDogTime(int wdt)
            /// <summary>
            /// This function retrieves the watchdog time.
            /// </summary>
            /// <param name="wdt">[in] Specifies the Watchdog type:
            /// 0: pac_WDT_HW, 1: pac_WDT_OS</param>
            /// <returns>The return value is the watchdog time which has been assigned by
            /// pac_EnableWatchDog or pac_SetWatchDogTime.</returns>    
            [DllImport("PACSDK.dll", EntryPoint = "pac_GetWatchDogTime")]
            public static extern uint GetWatchDogTime(int wdt);

            //5.5. PAC_API void pac_RefreshWatchDog(int wdt)
            /// <summary>
            /// This function refreshes the watchdog.
            /// </summary>
            /// <param name="wdt">[in] Specifies the Watchdog type:
            /// 0: pac_WDT_HW, 1: pac_WDT_OS</param>
            [DllImport("PACSDK.dll", EntryPoint = "pac_RefreshWatchDog")]
            public static extern uint RefreshWatchDog(int wdt);

            //5.6. PAC_API bool pac_SetWatchDogTime(int wdt, DWORD value)
            /// <summary>
            /// This function retrieves the watchdog time.
            /// </summary>
            /// <param name="wdt">[in] Specifies the Watchdog type:
            /// 0: pac_WDT_HW, 1: pac_WDT_OS</param>
            /// <returns>The return value is the watchdog time which has been assigned by
            /// pac_EnableWatchDog or pac_SetWatchDogTime.</returns>    
            /// <param name="value">[in] Specifies the watchdog time.</param>
            /// <returns>Return true if success, otherwise false.</returns>    
            [DllImport("PACSDK.dll", EntryPoint = "pac_SetWatchDogTime")]
            [return: MarshalAs(UnmanagedType.I1)]
            public static extern bool SetWatchDogTime(int wdt, uint value);
        }
    }
}